/**
 * Copyright 2013 Peergreen S.A.S.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ow2.util.osgi.toolkit.filter;

import java.util.Arrays;
import java.util.List;

/**
* A {@code NAryFilter} is ...
*
* @author Guillaume Sauthier
*/
class NAryFilter extends AbstractFilter {

    private final String operand;
    private final List<IFilter> chain;

    public NAryFilter(final String operand, final IFilter... chain) {
        this(operand, Arrays.asList(chain));
    }

    public NAryFilter(String operand, List<IFilter> chain) {
        this.operand = operand;
        this.chain = chain;
    }

    public String asText() {
        StringBuilder sb = new StringBuilder();
        sb.append("(");
        sb.append(operand);
        for (IFilter filter : chain) {
            if (filter != null) {
                sb.append(filter.asText());
            }
        }
        sb.append(")");
        return sb.toString();
    }
}
